

/*
 * lkud.frag -- lookup device fragment
 *
 * The caller may define:
 *
 *	HASBLKDEV	to activate block device lookup
 *
 * $Id: lkud.frag,v 1.4 96/07/29 07:45:52 abe Exp $
 */


#if	defined(HASBLKDEV)


/*
 * lkupbdev() - look up a block device
 */

struct l_dev *
lkupbdev(dev, i)
	dev_t *dev;			/* pointer to device number */
	int i;				/* inode match status */
{
	long inode;
	int low, hi, mid, ty;
	struct l_dev *dp;

	readdev();
	if (i) {
		inode = (long)Lf->inode;
		ty = Lf->inp_ty;
	}
/*
 * Search block device table for match.
 */
	low = mid = 0;
	hi = BNdev - 1;
        while (low <= hi) {
                mid = (low + hi) / 2;
		dp = BSdev[mid];
		if (*dev < dp->rdev)
			hi = mid - 1;
		else if (*dev > dp->rdev)
                        low = mid + 1;
                else {
			if (i == 0 || ty != 1 || inode == dp->inode)
				return(dp);
			if ((long)Lf->inode < (long)dp->inode)
				hi = mid - 1;
			else
				low = mid + 1;
		}
	}
	return(NULL);
}
#endif	/* defined(HASBLKDEV) */


/*
 * lkupdev() - look up a character device
 */

struct l_dev *
lkupdev(dev, i)
	dev_t *dev;			/* pointer to device number */
	int i;				/* inode match status */
{
	long inode;
	int low, hi, mid, ty;
	struct l_dev *dp;

	readdev();
	if (i) {
		inode = (long)Lf->inode;
		ty = Lf->inp_ty;
	}
/*
 * Search device table for match.
 */
	low = mid = 0;
	hi = Ndev - 1;
        while (low <= hi) {
                mid = (low + hi) / 2;
		dp = Sdev[mid];
		if (*dev < dp->rdev)
			hi = mid - 1;
		else if (*dev > dp->rdev)
                        low = mid + 1;
                else {
			if (i == 0 || ty != 1 || inode == dp->inode)
				return(dp);
			if ((long)Lf->inode < (long)dp->inode)
				hi = mid - 1;
			else
				low = mid + 1;
		}
	}
	return(NULL);
}
